;; NetworkManager.scm -- NetworkManager daemon

(define usr-sbin-dir "/usr/sbin/")
(define NM (cat usr-sbin-dir "NetworkManager"))

(define NetworkManager-service
  (make <service>
    #:requires '(networking)
    #:provides '(NetworkManager)
    #:start (lambda args
	      (if (file-exists? NM)
		  (begin
		    (boot-format "[....] Starting NetworkManager...")
		    (let ((ret ((make-forkexec-constructor (list NM "--no-daemon")))))
		      (boot-format-ok)
		      ret))
		  (begin
		    (boot-format-fail)
		    #f)))
    #:stop (lambda (running)
	     (when running
		   (boot-format "[....] Stopping NetworkManager...")
		   (catch-system-error (kill running SIGTERM))
		   (boot-format-ok))
	     #f)
    ))

(register-services NetworkManager-service)
