;; anacron.scm -- anacron script

(define usr-sbin-dir "/usr/sbin/")
(define anacron (cat usr-sbin-dir "anacron"))

(define anacron-service
  (make <service>
    #:requires '(cron)
    #:provides '(anacron)
    #:start (lambda args
	      (when (file-exists? anacron)
		    (boot-format "[....] Starting anacron...")
		    (if ((make-forkexec-constructor (list anacron "-s")))
			(begin
			  (boot-format-ok)
			  #t)
			(begin
			  (boot-format-fail)
			  #f)
			)))
    #:stop (lambda (running)
	     ;; anacron runs only from time to time, so kill it when it happens at reboot/shutdown time
	     (boot-format "[....] Stopping anacron...")
	     ;; TODO: kill children
	     (killall anacron)
	     (boot-format-ok))
    ))

(register-services anacron-service)
