;; dhcpcd.scm -- dhcpcd daemon

(define usr-sbin-dir "/usr/sbin/")
(define dhcpcd (cat usr-sbin-dir "dhcpcd"))

(define dhcpcd-piddir "/var/run/dhcpcd")
(define dhcpcd-pidfile (cat dhcpcd-piddir "/pid"))

(define dhcpcd-service
  (make <service>
    #:requires '(networking)
    #:provides '(dhcpcd)
    #:start (lambda args
	      (if (file-exists? dhcpcd)
		  (begin
		    (boot-format "[....] Starting dhcpcd...")
		    ((make-forkexec-constructor (list dhcpcd "-b") #:pid-file dhcpcd-pidfile))
		    (boot-format-ok)
		    #t)
		  (begin
		    (boot-format-fail)
		    #f)))
    #:stop (lambda (running)
	     (when (and running (file-exists? dhcpcd-pidfile))
	       (boot-format "[....] Stopping dhcpcd...")
	       (let ((pid (with-input-from-file dhcpcd-pidfile read)))
		 (delete-file dhcpcd-pidfile)
		 (catch-system-error (kill pid SIGTERM)))
	       (boot-format-ok))
	     #f)
    ))

(register-services dhcpcd-service)
