;; fullnetwork.scm -- virtual service, ensuring that all network interfaces
;; (vpn, ppp...) are started if they exist

(define fullnetwork-service
  (make <service>
    #:requires '(rsyslogd) ;; assumes we don't do fancy stuff like remote syslog through a tunnel
    #:provides '(fullnetwork)
    #:start (lambda args
	      (let ((serv (lookup-services 'openvpn)))
		(unless (null? serv)
		  (start (car serv))))
	      #t)
    #:stop (lambda (running)
	     (let ((serv (lookup-services 'openvpn)))
	       (unless (null? serv)
		 (stop (car serv))))
	     #f)
    )
  )

(register-services fullnetwork-service)
