;; getty.scm -- consoles login daemons

(define sbin-dir "/sbin/")
(define getty (cat sbin-dir "getty"))

(define getty2-service
  (make <service>
    #:provides '(getty2)
    #:requires '(single-user)
    #:start (make-forkexec-constructor (list getty "38400" "tty2"))
    #:stop (make-kill-destructor)
    #:respawn? #t
    )
  )

(register-services getty2-service)

(define getty3-service
  (make <service>
    #:provides '(getty3)
    #:requires '(single-user)
    #:start (make-forkexec-constructor (list getty "38400" "tty3"))
    #:stop (make-kill-destructor)
    #:respawn? #t
    )
  )

(register-services getty3-service)

(define gettyUSB0-service
  (make <service>
    #:provides '(gettyUSB0)
    #:requires '(single-user)
    #:start (lambda args
	      (if (file-exists? "/dev/ttyUSB0")
		  ((make-forkexec-constructor (list getty "9600" "ttyUSB0")))
		  #f))
    #:stop (make-kill-destructor)
    #:respawn? #t
    )
  )

(register-services gettyUSB0-service)

;; the console for Xen
(define gettyhvc0-service
  (make <service>
    #:provides '(gettyhvc0)
    #:requires '(single-user)
    #:start (lambda args
              (if (file-exists? "/dev/hvc0")
                  ((make-forkexec-constructor (list getty "38400" "hvc0")))
                  #f))
    #:stop (make-kill-destructor)
    #:respawn? #t
    )
  )

(register-services gettyhvc0-service)

;; some ARM devices
(define gettymxc0-service
  (make <service>
    #:provides '(gettymxc0)
    #:requires '(single-user)
    #:start (lambda args
              (if (file-exists? "/dev/ttymxc0")
		  ;; as this is a real serial port, we keep the current baud rate
                  (let ((sp (system-value* "/usr/bin/stty" "-F" "/dev/ttymxc0" "speed")))
                    ((make-forkexec-constructor (list getty sp "ttymxc0"))))
                  #f))
    #:stop (make-kill-destructor)
    #:respawn? #t
    )
  )

(register-services gettymxc0-service)

