;; generated with `guild compile-ffi ffi/utmp.ffi'

(define-module (ffi utmp)
  #:use-module (system ffi-help-rt)
  #:use-module ((system foreign) #:prefix ffi:)
  #:use-module (bytestructures guile)
  )
(define ffi-utmp-llibs (list))

;; extern void updwtmp(const char *__wtmp_file, const struct utmp *__utmp);
(define updwtmp
  (let ((~updwtmp
          (delay (fh-link-proc
                   ffi:void
                   "updwtmp"
                   (list ffi-void* ffi-void*)
                   ffi-utmp-llibs))))
    (lambda (__wtmp_file __utmp)
      (let ((~__wtmp_file (unwrap~pointer __wtmp_file))
            (~__utmp (unwrap~pointer __utmp)))
        ((force ~updwtmp) ~__wtmp_file ~__utmp)))))
(export updwtmp)

;; extern int utmpname(const char *__file);
(define utmpname
  (let ((~utmpname
          (delay (fh-link-proc
                   ffi:int
                   "utmpname"
                   (list ffi-void*)
                   ffi-utmp-llibs))))
    (lambda (__file)
      (let ((~__file (unwrap~pointer __file)))
        ((force ~utmpname) ~__file)))))
(export utmpname)

;; extern void setutent(void);
(define setutent
  (let ((~setutent
          (delay (fh-link-proc
                   ffi:void
                   "setutent"
                   (list)
                   ffi-utmp-llibs))))
    (lambda () (let () ((force ~setutent))))))
(export setutent)

;; extern void endutent(void);
(define endutent
  (let ((~endutent
          (delay (fh-link-proc
                   ffi:void
                   "endutent"
                   (list)
                   ffi-utmp-llibs))))
    (lambda () (let () ((force ~endutent))))))
(export endutent)

;; extern struct utmp *pututline(const struct utmp *__utmp_ptr);
(define pututline
  (let ((~pututline
          (delay (fh-link-proc
                   ffi-void*
                   "pututline"
                   (list ffi-void*)
                   ffi-utmp-llibs))))
    (lambda (__utmp_ptr)
      (let ((~__utmp_ptr (unwrap~pointer __utmp_ptr)))
        ((force ~pututline) ~__utmp_ptr)))))
(export pututline)

;; struct utmp {
;;   short int ut_type; /* Type of login.  */
;;   pid_t ut_pid; /* Process ID of login process.  */
;;   char ut_line[32]; /* Devicename.  */
;;   char ut_id[4]; /* Inittab ID.  */
;;   char ut_user[32]; /* Username.  */
;;   char ut_host[256]; /* Hostname for remote login.  */
;;   struct exit_status ut_exit; /* Exit status of a process marked
;;      as DEAD_PROCESS.  */
;;   /* The ut_session and ut_tv fields must be the same size when compiled
;;      32- and 64-bit.  This allows data files and shared memory to be
;;      shared between 32- and 64-bit applications.  */
;;   int32_t ut_session; /* Session ID, used for windowing.  */
;;   struct {
;;     int32_t tv_sec; /* Seconds.  */
;;     int32_t tv_usec; /* Microseconds.  */
;;   } ut_tv; /* Time entry was made.  */
;;   int32_t ut_addr_v6[4]; /* Internet address of remote host.  */
;;   char __glibc_reserved[20]; /* Reserved for future use.  */
;; };
(define-public struct-utmp-desc
  (bs:struct
    (list `(ut_type ,short)
          `(ut_pid ,int)
          `(ut_line ,(bs:vector 32 int8))
          `(ut_id ,(bs:vector 4 int8))
          `(ut_user ,(bs:vector 32 int8))
          `(ut_host ,(bs:vector 256 int8))
          `(ut_exit
             ,(bs:struct
                (list `(e_termination ,short) `(e_exit ,short))))
          `(ut_session ,int32)
          `(ut_tv ,(bs:struct
                     (list `(tv_sec ,int32) `(tv_usec ,int32))))
          `(ut_addr_v6 ,(bs:vector 4 int32))
          `(__glibc_reserved ,(bs:vector 20 int8)))))
(define-fh-compound-type struct-utmp struct-utmp-desc struct-utmp? 
 make-struct-utmp)
(export struct-utmp struct-utmp? make-struct-utmp)
(define-public struct-utmp*-desc
  (bs:pointer struct-utmp-desc))
(define-fh-pointer-type struct-utmp* struct-utmp*-desc struct-utmp*? 
 make-struct-utmp*)
(export struct-utmp* struct-utmp*? make-struct-utmp*)
(ref<->deref!
  struct-utmp*
  make-struct-utmp*
  struct-utmp
  make-struct-utmp)

;; access to enum symbols and #define'd constants:
;; unable to generate constant for "errno"
;; unable to generate constant for "ut_addr"
;; unable to generate constant for "ut_xtime"
;; unable to generate constant for "ut_time"
;; unable to generate constant for "ut_name"
(define ffi-utmp-symbol-tab
  '((_UTMP_H . 1)
    (UTMP_FILE . "/var/run/utmp")
    (UTMP_FILENAME . "/var/run/utmp")
    (WTMP_FILE . "/var/log/wtmp")
    (WTMP_FILENAME . "/var/log/wtmp")
    (UT_LINESIZE . 32)
    (UT_NAMESIZE . 32)
    (UT_HOSTSIZE . 256)
    (EMPTY . 0)
    (RUN_LVL . 1)
    (BOOT_TIME . 2)
    (NEW_TIME . 3)
    (OLD_TIME . 4)
    (INIT_PROCESS . 5)
    (LOGIN_PROCESS . 6)
    (USER_PROCESS . 7)
    (DEAD_PROCESS . 8)
    (ACCOUNTING . 9)
    (UT_UNKNOWN . 0)
    (_HAVE_UT_TYPE . 1)
    (_HAVE_UT_PID . 1)
    (_HAVE_UT_ID . 1)
    (_HAVE_UT_TV . 1)
    (_HAVE_UT_HOST . 1)
    (_ERRNO_H . 1)))
(define ffi-utmp-symbol-val
  (lambda (k)
    (or (assq-ref ffi-utmp-symbol-tab k))))
(export ffi-utmp-symbol-val)

(define (unwrap-enum obj)
  (cond ((number? obj) obj)
        ((symbol? obj) (ffi-utmp-symbol-val obj))
        ((fh-object? obj) (struct-ref obj 0))
        (else (error "type mismatch"))))

(define ffi-utmp-types
  '((struct . "utmp")))
(export ffi-utmp-types)

;; --- last line ---
