;; processes.scm -- running processes

(define (system-value command)
  "Return first line of output when calling (system command)"
  (let* ((port (open-input-pipe command))
	 (str (read-line port)))
    (close-pipe port)
    str))

(define (system-value* command . args)
  "Return first line of output when calling (system* command . args)"
  (let* ((port (apply open-pipe* OPEN_READ command args))
	 (str (read-line port)))
    (close-pipe port)
    str))

(define (system-pipe command proc)
  "Output of (system command) is handled line by line by proc"
  (let ((port (open-input-pipe command)))
    (do ((str (read-line port) (read-line port)))
	((eof-object? str) (close-pipe port))
      (proc str))))
